=== debian/changelog ===
libiio (0.6.40-1) unstable; urgency=medium

  * Initial upload to Debian (closes: #814032)
  * Sponsor libiio for Paul Cercueil
  * Update to v0.6-40-g93b5950
  * repackage as 3.0 (quilt)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 07 Feb 2016 15:10:46 -0500

libiio (0.6) unstable; urgency=low
  * Improved parsing of sysfs files
  * Added iio_reg test program
  * Revert to regular I/O in the network backend if zerocopy is not available
  * Fix bugs reported by Valgrind
  * IIOD can now run interactively from the terminal
  * Improved I/O handling in IIOD
  * New API functions

 -- Paul Cercueil <paul.cercueil@analog.com>  Tue, 4 Dec 2015 12:58:52 +0200

libiio (0.5) unstable; urgency=low

  * Fix locales support on Windows and MinGW
  * Add iio_adi_xflow_check tool
  * Boost client->server transfers using delayed error reporting
  * Enable support for zero-copy transfers in the network backend
  * Created packages for the Python and C# bindings
  * Lots of improvements on the Python and C# bindings
  * Enhanced error reporting

 -- Paul Cercueil <paul.cercueil@analog.com>  Tue, 24 Mar 2015 13:19:22 +0200

libiio (0.4) unstable; urgency=low

  * Boost communication speed of the network backend
  * Fix socket I/O timeout on UNIX systems
  * New API function: iio_context_get_description

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 6 Feb 2015 11:42:01 +0200

libiio (0.3) unstable; urgency=low

  * Improved error handling
  * IPv6 support in both libiio and iiod
  * Enhanced CMake build scripts (now builds under MinGW and Windows)
  * Old Makefile-based build system has been dropped
  * Scripts to create Debian packages

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 12 Dec 2014 17:14:59 +0200

libiio (0.2) unstable; urgency=low

  * Initial release.

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 28 Nov 2014 14:51:18 +0200
