=== debian/changelog ===
libiio (0.7-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 10 Jul 2016 11:34:33 -0400
